<script setup lang="ts">
import { storeToRefs } from 'pinia'
import { useUIStore } from '~~/store/UI'

interface Props {
  startTab?: number
}

const { startTab = 0 } = defineProps<Props>()

const tempObj = {
  info: '情報',
  comment: 'コメント',
  question: '質問',
  poll: 'アンケート',
}

type keyTemp = keyof typeof tempObj
const slots = useSlots()
const tabTitles = slots.default ? ref(slots.default().map(tab => tab.props?.title).filter(i => i)) : ref([])
const ui = useUIStore()
const { selectedTitle } = storeToRefs(ui)
selectedTitle.value = tabTitles.value[startTab]
const { isMobile, mTabFull, sideBar, isDesign7 } = storeToRefs(ui)
provide('selectedTitle', selectedTitle)

// const
const notifyEvent = reactive([] as { tab: string; value: number }[])
const notifyObj = reactive(tabTitles.value.reduce((acc, cur) => ({
  ...acc,
  [cur]: 0,
}), {}))
provide('notifyEvent', notifyEvent)

watch(
  () => notifyEvent.length,
  () => {
    const lastEvent = notifyEvent[notifyEvent.length - 1]
    if (lastEvent.tab !== selectedTitle.value) {
      notifyObj[lastEvent.tab] += lastEvent.value
      notifyObj[lastEvent.tab] = Math.max(notifyObj[lastEvent.tab], 0)
    }
  },
)

const onClick = () => {
  if (isMobile.value)
    mTabFull.value = true
}
</script>

<template>
  <div class="tabs flex flex-col">
    <div v-show="(mTabFull || isDesign7)" class="bg-neutral-900 w-full p-2">
      <div bg-neutral-300 flex justify-between items-center rounded-lg text-black>
        <div pl-5>
          {{ tempObj[selectedTitle as keyTemp] }}
        </div>
        <div
          class="i-ph:x-fill w-8 h-8" mr-2 cursor-pointer
          @click="() => {
            mTabFull = false
            sideBar = false
          }"
        />
      </div>
    </div>
    <ul v-show="!mTabFull && (!isDesign7)" class="tabs__header text-base " @click="onClick">
      <li
        v-for="title in (tabTitles as keyTemp[])"
        :key="title"
        class="tabs__item text-white after:bg-red-600 after:text-white flex justify-center items-center p-1 lt-md:py-1"
        :class="{ selected: selectedTitle === title }"
        :data-noti="notifyObj[title]"
        @click="
          () => {
            notifyObj[title] = 0
            selectedTitle = title
          }
        "
      >
        <div v-if="title === 'info'" class="i-bi:person-fill" />
        {{ title === "info" ? "" : tempObj[title] }}
      </li>
    </ul>
    <slot />
  </div>
</template>

<style scoped lang="scss">
.tabs {
  margin: 0 auto;
}

.tabs__header {
  list-style: none;
  padding: 0;
  margin: 0;
  display: flex;
  justify-content: space-between;
  gap: 5px;

  li {
    position: relative;

    &[data-noti='0'] {
      &::after {
        display: none;
      }
    }

    &::after {
      height: 1.5rem;
      width: 1.5rem;
      -webkit-border-radius: 100%;
      -moz-border-radius: 100%;
      border-radius: 100%;
      position: absolute;
      top: 0;
      left: 0;
      transform: translate(-20%, -50%);
      display: flex;
      justify-content: center;
      align-items: center;
      content: attr(data-noti);
    }
  }
}
.tabs__item {
  flex: 1;
  @apply bg-neutral-300 dark:bg-neutral-600;
  border-radius: 5px 5px 0 0;
  transition: 0.4s all ease-out;
  cursor: pointer;
  user-select: none;
  @media screen and (max-width: 600px) {
    &:nth-child(1){
      flex:none;
      padding: 0 20px;
    }
  }
}

.tabs__item.selected {
  @apply bg-white dark:bg-neutral-900 text-white;
}
</style>
